# uorss
Pixiv to RSS bridge written in bash.

## Setup
1. `$ cd $UORSS_DIR && mkdir -p cache/artwork cache/feeds cache/pages cache/users config.d`
2. Add appropriate settings in config.d. `touch config.d/0_secrets.yaml config.d/1_config.yaml config.d/2_watchlist.yaml`
3. Add cronjob or systemd scheduled service. Set `$UORSS_DIR`!
4. Expose `feeds/` and `pages/` with nginx or httpd. You should use a dedicated root with symlinks to each, don't blindly expose your `$UORSS_DIR` directory!

### `config`
```yaml
required: [ user_agent, session_id, base_url, pixiv_base_url, depth ]
properties:
  user_agent:
    comment: 'User Agent send for all requests. Must be a browser user agent otherwise requests wont go through'
    type: string
  session_id:
    comment: 'Contents of PHPSESSID for a logged in pixiv session. You should put this in it's own config file'
    type: string
  base_url:
    comment: 'The base url where you will expose feeds/ and pages/ on your server'
    example: 'http://10.0.0.2/static/uorss'
    type: string
  pixiv_base_url:
    comment: 'The base url for pixiv links that uorss generates (tags)' 
    example: 'https://www.pixiv.net/en'
    type: string
  depth:
    comment: 'How many illustrations you want uorss to pull. Suggested value is 3. Note that uorss will not clean up stale illustrations it downloads!'
    type: number
  stale_mode:
    comment: "Always use cached pixiv user responses. This is for testing so you don't spam the pixiv api with artist lookups"
    suggested: false
    type: boolean
  cache_entry_files:
    comment: 'If entry files should always regenerate. If uorss updates you should set this to false for the first run'
    suggested: true
    type: boolean
  slow_mode:
    comment: "Adds various delays while pulling from pixiv. Use if you're worried about being rate limited or while syncing a lot of artists"
    type: boolean
  artist:
    comment: 'An array of pixiv artist ids. Uorss will not check for duplicates'
    type: array
    items:
      type: string
```
